//We give the map handler a global var for easy access.
var/UMMC_Controller/mapper


world
	turf = /turf/ground
	name = "MapCompress demo"


	New()
		. = ..()
		//world.New is a good place to create the map handler.
		mapper = new()
		mapper.SetMaxZ(world.maxz)
		mapper.SetBodyDef( \
			"color:#00FF00;background:#000000")

		//Uncomment the next line if you wish to disable compression!
		//mapper.SetCompression(0)


turf
	ground
		icon_state = "ground"


	rock
		icon_state = "rock"


	wall
		icon_state = "wall"
		UMMC_mapText = "#"
		density = 1


	door
		icon_state = "door"

		/* Notice that in this demo, walls and doors have the same map text.
		This could be a poor decision, because we've said we want doors to be clickable links --
		but if walls and doors use the same text, the doors could get compressed out of the map!
		Map level 2 is a perfect example -- every single one of the doors will vanish unless we
		give the door object its own unique map text (try changing it to "D" and see).
		*/
		UMMC_mapText = "#"

		//We want doors to have clickable links on the compressed map.
		UMMC_mapLink = 1
		density = 1


		proc/Toggle(mob/M)
			if(density == 1)
				density = 0
				icon_state = ""
			else
				density = 1
				icon_state = initial(icon_state)

			M << "You have manipulated the door."


		UMMC_HandleMapClick(mob/clicker)
			/* This is an example of how to override the library-provided
			UMMC_HandleMapClick proc. See the directory object, below, to find out
			why we might want to do this.
			*/
			if(clicker.CheckMapAccess()) src.Toggle(clicker)
			else clicker << "You must be viewing a directory to manipulate doors!"


	directory
		/* When the user is standing next to one of these, he can view the map, and
		can click doors on the map to open and close them. But once the map is generated, a
		clever player may try to click on it even when he's not near a directory! That's why
		UMMC_HandleMapClick is overridden above to make sure everything's kosher.
		*/
		icon_state = "directory"
		UMMC_mapText = "<font color=\"red\">?</font>"


mob
	icon_state = "mob"


	verb/textmap(mapLevel as num)
		if(!usr.CheckMapAccess())
			usr << "Nice try, chump! You need to be near a map."
			return
		usr.loc = locate(usr.x, usr.y, mapLevel)
		usr << mapper.GetMap(mapLevel)


	verb/browsemap(mapLevel as num)
		if(!usr.CheckMapAccess())
			usr << "Nice try, chump! You need to be near a map."
			return
		usr.loc = locate(usr.x, usr.y, mapLevel)
		usr << browse(mapper.GetMap(mapLevel))


	proc/CheckMapAccess()
		if(locate(/turf/directory) in oview(src, 1)) return 1


	Login()
		. = ..()
		src << "There are three map levels to view. Use the verbs with a level number"
		src << "to see how they are compressed. Compare them to the full maps in the"
		src << "Dream Maker map editor."


atom
	icon = 'generic.dmi'


